<?php if (!defined('PmWiki')) exit();

/* fox.php, a form processing extension to PmWiki 2. Copyright Hans Bracker 2007.
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published
   by the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   Other contributors:
   * Original script adddeleteline2.php by Nils Knappmeier (nk@knappi.org)
   * AccessCode code from commentbox.php by John Rankin
   * Code review (using htmlentities instead of urlencode) and some of the code
     for processing {name[]} markup in the template by Martin Fick (2006)
   * Original deletelink directive by Petko Yotov (2006)
   * Permission check on idea by Patrick R. Michaud
   * FoxFilter hook and other improvements by Feral
 */
$RecipeInfo['Fox']['Version'] = '2007-04-21';

// auth permission level for adding and deleting posts. 
// 'edit': needs edit permission. 
// 'read': needs read permission (can post to edit protected pages) 
// 'ALWAYS':no permission needed, can also post to 'read' protected pages.
SDV($FoxAuth, 'edit');  
SDV($EnablePostDirectives, false); //set to true to allow posting of directives of form (: :)
SDV($EnableAccessCode, false);  //set to true to enable accesscode check (needs access code form fields as well)
SDV($EnableFoxDeleteMsg, false); //set to true to enable post delete confirmation 

# Default patterns for allowed and disallowed page names (use of wildcards possible)
SDVA($FoxNameFmt, array(
    'no-site'   => '-$SiteGroup.*',       // no pages in SiteGroup
    'no-pmwiki' => '-PmWiki.*',           // no pages in PmWiki group
  //'fn-talk'   => '{$FullName}-Talk',    // page with -Talk prefix in current group
  //'fn-discuss'=> '{$FullName}-Discuss', // page with -Discuss prefix in current group
    'current'   => '{$Group}.{$Name}',    // current page
    'group'     => '{$Group}.*',          // all pages in current group    
    '-comment'  => '*.{$Name}-Comment',   // pages with -Comment prefix in any group
    'comments-g-n'=> 'Comments.{$Group}-{$Name}', //pages in Comments group with name 'Group-Name'
  //'comments'  =>  'Comments.*',          // all pages in Comments group
  //'all'       =>  '*.*',                 // all pages
));

# load special styles for delete button and links and for message classes
$HTMLHeaderFmt['Fox'] = "   
   <link href='$FarmPubDirUrl/fox/fox.css' rel='stylesheet' type='text/css' media='screen' />
   ";


## Creates the HTML code for the (:fox name [placement] [parameters]:) directive
function FoxFormMarkup($pagename, $name, $place="", $opt ) {
    global $ScriptUrl;
    $opt = ParseArgs($opt);
    if($opt['redirect']) { $opt['redir'] = $opt['redirect']; unset($opt['redirect']);}  
    if ($opt['formcheck']) $javacheck = FoxFormCheck($opt['formcheck']); 
    else $javacheck = '';
    $out = $javacheck;
    $out.= "<form action='$ScriptUrl' method='post' ".
          ($opt['formcheck'] ? "onsubmit='return checkform(this);'> \n" : "> \n").
            "<input type='hidden' name='foxpage' value='$pagename' /> \n".
            "<input type='hidden' name='action' value='foxpost' /> \n".
            "<input type='hidden' name='foxname' value='$name' /> \n".
          ($place ? "<input type='hidden' name='foxplace' value='$place' />\n" : ""); 
    foreach($opt as $key => $arg)
       if(!is_array($arg))
         $out.= "<input type='hidden' name='".$key."' value='".$arg."' /> \n";
    return Keep($out);
} //}}}
Markup('foxform','directives','/\(:fox\\s+([\\w]+)\\s?(#\\w+)*\\s*(.*?)\\s*:\)/e',"FoxFormMarkup(\$pagename, PSS('$1'), PSS('$2'), PSS('$3'))");

# Creates the HTML code for delete links {[foxdelline]}, {[foxdelrange]}
# and delete butons {[foxdelline button]} and {[foxdelrange button]}
function FoxDeleteMarkup($pagename, $key='dummy', $targetname="", $range, $type) {
    global $EnableFoxDeleteMsg, $HTMLStylesFmt;
    if ($targetname=="") $targetname = $pagename;
    # javascript delete message dialogue
    SDV($FoxDeleteMsg, '$[Really delete this post?]');
    if($EnableFoxDeleteMsg==true) 
         $onclick = "onclick='if(confirm(\"".$FoxDeleteMsg."\")) self.open(\"{\$PageUrl}?action=foxdelete&amp;linekey=$key&amp;base=$pagename\", \"_self\")'";
    else $onclick = "";    
    if($type=='button') {
      # delete button
      return FmtPageName("<form class='foxdelbutton' action='{\$PageUrl}' method='post'>
            <input type='hidden' name='n' value='$targetname' />
            <input type='hidden' name='base' value='$pagename' />
            <input type='hidden' name='action' value='foxdelete' />
            <input type='hidden' name='linekey' value='$key' />
            <input type='submit' name='doit' value='$[Delete]' class='inputbutton' ".$onclick."/>
            </form>",$targetname);    
    }
    else    
       # delete link which works with and without javascript:
       return FmtPageName("<a class='foxdellink' href='{\$PageUrl}?action=foxdelete&amp;linekey=$key&amp;base=$pagename' rel='nofollow'
              ".$onclick.">$[Delete]</a>",$targetname);
} //}}}
Markup('foxdelete','directives','/\{\[foxdel(line|range)\\s*(|button)\\s+(\\w+)\\s*(.*?)\\s*\]}/e',
        "Keep(FoxDeleteMarkup(\$pagename, PSS('$3'), PSS('$4'), '$1', '$2'))");

# Creates the HTML code for (:foxtemplate "templatestring":) as hidden input form field
# $template is the template string
function FoxTemplateMarkup($template) {
    $template = str_replace('"', '', $template);
    return '<input type="hidden" name="foxtemplate" value="'.htmlentities($template, ENT_QUOTES).'"/>';
} //}}}
Markup('foxtemplate','[=','/\(:foxtemplate\\s+(.*)\\s*:\)/e',"Keep(FoxTemplateMarkup(PSS('$1')))");
# (:foxend:)
Markup('foxendform','directives','/\(:foxend(\\s[\\w]+):\)/', "</form>");
# (:foxprepend:) and (:foxappend:) just vanish because they are only used later in  FoxAddEntry
Markup('foxaprepend','directives','/\(:fox(ap|pre)pend (.*?):\)/e','');
# #foxbegin# and #foxend# invisible markers
Markup('foxentry','<fulltext','/#fox(begin|end)( \w+)?#/','');


# add FoxEditTemplate to $EditFunctions for FoxHandlePost
if($action=='edit' && $_REQUEST['foxtemptext']==1) 
   array_unshift($EditFunctions, 'FoxEditTemplate');

## provide page text for ?action=edit&foxtemptext=1
function FoxEditTemplate($pagename, &$page, &$new) {
   if (@$new['text'] > '') return;
   if (@$_REQUEST['foxtemptext'])  {
      if ($_SESSION["FoxTempPageText"] > '') $new['text'] = $_SESSION["FoxTempPageText"];
         return;
   }
} //}}}


## add action foxpost
$HandleActions['foxpost']='FoxHandlePost';

## Main post function. Insert text into page
function FoxHandlePost($pagename) {
   if(isset($_POST['n'])) Redirect($pagename); 
   if(isset($_POST['foxpage'])) $pagename = $_POST['foxpage'];

   //initialise
   $basename = $pagename;
   $targetname  = $pagename;
   $fields = array();
   
   //get POST data so we can manipulate it as we wish.
   foreach ($_POST as $name => $value) {
      if (is_array($value)) $value = implode(",", $value); //array as value
  //    $fields[$name] = stripmagic($value);
      $fields[$name] = $value;
      
   }
//DEBUG//foreach ($fields as $name => $value)  echo "FIELDS>".$name."::".$value."|| ";      

   //preprocess fields with FoxFilter, which calls external filter functions 
   if (isset($fields['foxfilter'])) 
      $fields = FoxFilter($pagename, $fields); 

   //do {$$var} field substitutions
   $fields = FoxFieldSubstitutions($fields);  

   //create $targtemp ( target => template ) array
   if(isset($fields['template'])) 
         $templates = explode(",", $fields['template']);
   if(isset($fields['target'])) { 
      $target = explode(",", $fields['target']);
      if($target) foreach ($target as $i => $t)  
         $targtemp[$t] = $templates[$i];
      //rebuild target array index
      foreach ($target as $t => $val) { 
         $fields['target['.$t.']'] = $val;
      }   
   }
   //set current page as target
   if(!isset($fields['newedit']) && !isset($fields['target'])) 
      $targtemp[$pagename] = $fields['template'];
      
   //check various security restrictions 
   FoxSecurityCheck($pagename, $fields);

//DEBUG//foreach ($fields as $name => $value)  echo "FIELDS>".$name."::".$value."|| ";      

   //process all target pages with corresponding templates
   if($targtemp) {
         foreach ($targtemp as $tgt => $tplpage) {
         //set target pagename
         if(isset($fields['foxgroup']))
              $targetname = FoxGroupName($pagename, $fields, $tgt);
         else $targetname = MakePageName($pagename, $tgt);
//DEBUG//echo " TARGET>>".$targetname;
         //set $basename for redirect
         $urlfmt = '$PageUrl';
         if(isset($fields['redir'])) {
            if($fields['redir']==1) $basename = $targetname;
            else $basename = MakePageName($pagename, $fields['redir']);
            if(isset($fields['urlfmt'])) $urlfmt = $fields['urlfmt'];
         }
         //load template
         $template = FoxLoadTemplate($pagename, $tplpage, $templates, $fields);
         // copy without template var substitutions
         if(isset($fields['foxcopy'])) FoxCopyPage($pagename, $targetname, $template);
         //add entry
         else FoxAddEntry($pagename, $targetname, $template, $fields);
      }
   }
   //open page to edit using newedit value, or jump to existing page
   if(isset($fields['newedit'])) { 
         if($templates) $templatepage = end($templates);
         $template = FoxLoadTemplate($pagename, $templatepage, $templates, $fields);
         if(isset($fields['foxgroup']))
              $targetname = FoxGroupName($pagename, $fields, 'newedit');
         else $targetname = MakePageName($pagename, $fields['newedit']);
         if(PageExists($targetname)) Redirect($targetname); //jump to existing page
         FoxNewEdit($pagename, $targetname, $template, $fields);   
   }
   Redirect($basename, $urlfmt);
} //}}}


## check 'foxgroup' and set targetname, $name is 'target' or 'newedit'
function FoxGroupName($pagename, $fields, $name) {
  //echo "FOXGROUP> "; //DEBUG//
      $group = preg_replace('/[\.\/]/', ' ', $fields['foxgroup']); //replace any . or / with space
      if (isset($fields['target'])) 
         $name = preg_replace('/[\.\/]/', ' ', $name);
      if (isset($fields['newedit']))
         $name = preg_replace('/[\.\/]/', ' ', $fields['newedit']);
      return MakePageName($pagename, "$group.$name");
}


## add a new entry
function FoxAddEntry($pagename, $targetname, $template, $fields) {
  //echo "ADDENTRY> "; //DEBUG//
   global $FoxAuth, $FoxNameFmt;
   // posting permission set by $FoxAuth and permission check against $FoxNameFmt
   $page = RetrieveAuthPage($targetname, $FoxAuth, true);
   $permit = (boolean)MatchPageNames($targetname,FmtPageName(implode(',', $FoxNameFmt), $pagename));
   if (!$page OR !$permit) {
      FoxAbort($pagename, "PERMISSION DENIED to edit $targetname! ");
   }
   $newpage = $page;

   # create new entries from $fields 
   $addstring = FoxTemplateEngine($targetname, $template, $fields, '', $id);  //decode the template

   # placing $addstring into the page text
   // Handle the special names #top and #bottom
   if($fields['foxplace']=='#top') $newpage['text'] = $addstring."\n".$page['text']; 
   elseif($fields['foxplace']=='#bottom') $newpage['text'] = $page['text']."\n".$addstring;
   // Handle locations specified by 'fox prepend' and 'fox append'
   else {  
      $textrows = explode("\n",$page['text']);
      // Handle the special names #prepend or #append
      // Look for (:foxappend ... or (:foxprepend ... and append or prepend the $
      $foxname = stripmagic($fields['foxname']);

      if(isset($fields['foxplace'])) $fp = $fields['foxplace'];
      else $fp = '#bottom'; //set default for placement
      if($fp=='#top'||$fp=='#bottom'||$fp=='#append'||$fp=='#prepend') $fplace = ""; 
      else $fplace = ' '.$fp;
      $formstart = '(:fox '.$foxname;
      $formend = '(:foxend '.$foxname;
      $app = '(:foxappend '.$foxname.$fplace.':)';
      $pre = '(:foxprepend '.$foxname.$fplace.':)';

      foreach ($textrows as $nr => $line) {
         if(strstr($line,$formend) AND $fp=='#prepend') {$done=1; $textrows[$nr] = "$line\n".$addstring; break; }
         if(strstr($line,$formstart) AND $fp=='#append') {$done=1; $textrows[$nr] = $addstring."\n$line"; break; }
         if(strstr($line,$pre)) {$done=1; $textrows[$nr] = "$line\n".$addstring; break; }
         if(strstr($line,$app)) {$done=1; $textrows[$nr] = $addstring."\n$line"; break; }
      }
      if($done==1) {
         $text = implode("\n",$textrows);
         $newpage['text'] = $text;
      }
      else { $newpage['text'] = $page['text']."\n".$addstring; } //default: append to bottom 
   }
   # save page
   UpdatePage($targetname, $page, $newpage);
   return '';
} //}}}


## newedit opens page in the edit form
function FoxNewEdit($pagename, $targetname, $template, $fields) {
  //echo "NEWEDIT> "; //DEBUG//    
   global $FoxNameFmt;
   $urlfmt = '$PageUrl?action=edit';
   if (@$fields['template'] OR @$fields['foxtemplate']) {
      // permission check against $FoxNameFmt
      $permit = (boolean)MatchPageNames($targetname,FmtPageName(implode(',', $FoxNameFmt), $pagename));
      if (!$permit) {
         FoxAbort($pagename, "PERMISSION DENIED to edit $targetname! ");
      }
      // set $id for post anchors, increment on each post
      $id = 1;
      // merging fields and template, put into Session var for use with ?action=edit&foxtemptext=1
      @session_start();
      $_SESSION["FoxTempPageText"] = FoxTemplateEngine($targetname, $template, $fields, '', $id);
      // add special template marker before redirecting to edit
      $urlfmt.= '&foxtemptext=1';
   }
   Redirect($targetname, $urlfmt); // open new page to edit
} //}}}


## copy template  to target without template var substitutions
function FoxCopyPage($pagename, $targetname, $template) {
   global $FoxAuth, $FoxNameFmt;
   // check permission
   $page = RetrieveAuthPage($targetname, $FoxAuth, true);
   $permit = (boolean)MatchPageNames($targetname,FmtPageName(implode(',', $FoxNameFmt), $pagename));
   if (!$page OR !$permit OR !$page['text']=="") {
      FoxAbort($pagename, "PERMISSION DENIED to copy to $targetname! ");
   }
   $newpage = $page;
   $newpage['text'] = $template;   
   UpdatePage($targetname, $page, $newpage);
   return '';   
} //}}}


## get template from template page or string
function FoxLoadTemplate($pagename, $templatepage, $templates, $fields) {
   // first check if no template is wanted
   if($fields['template']==="0") { echo "NOTMPL>"; 
      $template = ""; 
      return $template; 
   }
   //try to load template from template page
   $templatepage = MakePageName($pagename, $templatepage);
   if (PageExists($templatepage)) 
      $page = RetrieveAuthPage($templatepage,"read");
   //try to load template from first template page
   else {
      $templatepage = MakePageName($pagename, $templates[0]);
      if(PageExists($templatepage)) 
         $page = RetrieveAuthPage($templatepage,"read");
   }
   if ($page)
      $template = $page['text'];   
   //try to load template from (:foxtemplate "templatestring":) 
   if (!$template && $fields['foxtemplate']) 
      $template = html_entity_decode(stripmagic($fields['foxtemplate']));
   //if all failed abort
   if (!$template) { 
     FoxAbort($pagename, "NO TEMPLATE! Template page or string is missing! ");
   }
   return $template;          
} //}}}


# Processes $template provided and inserts the values of $fields array.
# $linekeyseed is an optional parameter that allows the caller to specify a seed for the linekey
# that is used to identify the range in the delete-action.
# The engine returns a string with the new entries. If no markup of the form {$$name[]}
# is present in the template, the array will contain exactly one entry, where the usual text substitutions have
# been performed.
# If a {$$name[]} markup is present, $fields['name'] has to be an array. For each element of $fields['name'],
# one entry is found in the array, where all the other fields are replicated, but {name[]} is substituted 
# by each element of $fields['name'].
# If more than one markups {$$name[]} are present, the outcome is undefined...
#
function FoxTemplateEngine($pagename, $template, $fields, $linekeyseed=NULL, $id) {
  //echo "ENGINE> "; //DEBUG//
    global $EnablePostDirectives, $EnableFoxBreakPage, $FoxPostsPerPage, $FoxBreakPageFmt;

    if($template=="") return '';

    // create the data to be added, from template and variables
    $string = $template;
    //replace \n by newlines
    $string = preg_replace('/\\\\n/',"\n",$string);  
    // replace {date:fmt}
    $string = preg_replace('/\\{\\$\\$\\(date[:\\s]+(.*?)\\)\\}/e',"date(PSS('$1'))",$string);  
    //replace {strftime:fmt}
    $string = preg_replace('/\\{\\$\\$\\(strftime[:\\s]+(.*?)\\)\\}/e',"strftime(PSS('$1'))",$string);  
    //prevent posting of directives (: ... :)
    if ($EnablePostDirectives==false) $fields = preg_replace('/\\(:/', "(&#x3a;", $fields );
    //replace {name} fields with values
    $string = preg_replace("/\\{\\$\\$([A-Za-z][-_:.\\w\\[\\]]*)\\}/e","stripmagic(\$fields[PSS('$1')])",$string); 
    
    //reiterate through array of {$$name[]}
    if(preg_match('/\\{\\$\\$(.*?)\[\]\}/', $string, $m)) {
        list($x, $name) = $m;
        $result = Array();
        foreach((array)$_POST[$name] as $val) 
            if ($val) $result[] = preg_replace("/\\{\\$\\$$name\\[\\]\\}/", $val, $string);
    } else $result = Array($string);
    
    //create a unique linekeyseed, if necessary
    if ($linekeyseed==NULL) $linekeyseed=time().'a'.rand(0,100000);
    
    foreach ($result as $index => $entry) {
        $linekey = $linekeyseed.'b'.$index;
        //adding linekey + pagename to any foxdelete markup for unique id
        $entry = str_replace('{[foxdelline button]}',"{[foxdelline button $linekey {\$FullName} ]}",$entry); // Add linekey to delete statements
        $entry = str_replace('{[foxdelline]}',"{[foxdelline $linekey {\$FullName} ]}",$entry); // for link-delete
        $entry = str_replace('{[foxdelrange button]}',"{[foxdelrange button $linekey {\$FullName} ]}",$entry); // Add linekey to delete statements
        $entry = str_replace('{[foxdelrange]}',"{[foxdelrange $linekey {\$FullName} ]}", $entry); // for link-delete
        $entry = str_replace('#foxbegin#',"#foxbegin $linekey#",$entry); //Add line-key to delete marker
        $entry = str_replace('#foxend#',"#foxend $linekey#",$entry); // Add line-key to delete marker
        $result[$index] = $entry;
    }
    return implode("\n",$result);
} //}}}


## call external filter functions
SDV($FoxFilterFunctions, array());
function FoxFilter($pagename, $fields) {
  //echo "FILTER> "; //DEBUG// 
   global $FoxFilterFunctions;
   //use specific filters
   $filters = preg_split("/[\s,|]+/", $fields['foxfilter'], -1, PREG_SPLIT_NO_EMPTY);
   foreach($filters as $filter) {
      $fifn = $FoxFilterFunctions[$filter];
      if (function_exists($fifn) ) { 
        //echo " FIFN>".$fifn; //DEBUG//
         // use specific filter
         if(is_callable($fifn, false, $callable_name)) {
            $fields = $callable_name($pagename, $fields);
            if(!$fields) Redirect($pagename); // Filter is telling us to abort;
         }  
      }  
   }  
   return $fields;
} //}}}


## substitute any {var} in fields with values
function FoxFieldSubstitutions($fields) {
  //echo "SUBST> "; //DEBUG//
   //check all fields for substitutions
   foreach($fields as $name => $value) {
      # Skip known ones:
      if (preg_match('/^(n|action|foxname|foxplace|foxfields|template)$/i', $name)) continue;
      # replace {$$name} fields with values
      $fields[$name] = preg_replace("/\\{\\$\\$([A-Za-z][-_:.\\w\\[\\]]*)\\}/e","stripmagic(\$fields[PSS('$1')])",$value);
   }
   return $fields;
} //}}}


## Delete one line or range of lines
$HandleActions['foxdelete']='FoxHandleDelete';
function FoxHandleDelete($pagename) {
    global $FoxAuth;
    # delete permission set by $FoxAuth
    $page = RetrieveAuthPage($pagename, $FoxAuth, true);
    if (!$page) FoxAbort($pagename, "ERROR: Cannot read $page! ");
    $newpage = $page;

    if(isset($_POST['linekey'])) $key = stripmagic($_POST['linekey']);  # Retrieve the line-key
    else $key = stripmagic($_GET['linekey']);

    # trim text and add newline so the following regexes also work for the last line
    $text = rtrim($page['text'])."\n";
    $old = $text;
    # Remove the line containing the delete statement with the provided line-key (if it exists)
    $text = preg_replace('/^.*\\{\\[foxdelline(| button)? '.$key.' .*\\n/m',"",$text);
    # Remove the range containing the delrange statement with the provided line-key (if it exists)
    $text = preg_replace('/#foxbegin '.$key.'#.*?\\{\\[foxdelrange(| button) '.$key.' .*?#foxend '.$key.'#.*?\n/s',"",$text);
    if($old==$text) 
         FoxAbort($pagename, "ERROR: Delete action was unsuccessful! ");
    # Remove the added newline character (or any whitespace from the end)
    $text = rtrim($text);
  
    # save page
    $newpage['text'] = $text;
    UpdatePage($pagename, $page, $newpage);    
    # set up page redirection, cater for deletelink ($_GET)
    if(@$_POST['base']) $pagename = $_POST['base'];
    elseif(@$_GET['base']) $pagename = $_GET['base'];
    Redirect($pagename);
} //}}}


## check access code and required fields
function FoxSecurityCheck($pagename, $fields) {
   //echo " SECURITY>";
   global $FoxAuth, $FoxNameFmt, $EnableAccessCode;
   // if enabled check for access code match 
   if($EnableAccessCode AND (!(isset($fields['access'])&&($fields['access']==$fields['accesscode'])))) { 
      FoxAbort($pagename, "ERROR: Missing or wrong Access Code! ");
   }
   // check if page names set with pagecheck exists already
   if(isset($fields['pagecheck'])) {
      if($fields['pagecheck']==1) 
         $fields['pagecheck'] = $fields['target'];
      $check = preg_split("/[\s,|]+/", $fields['pagecheck'], -1, PREG_SPLIT_NO_EMPTY);
      foreach ($check as $pt) {
         $page = MakePageName($pagename, $pt);
         if($pagename==$page) FoxAbort($pagename, "ERROR: You are not allowed to post to this page!");
         if(PageExists($page) AND strstr($fields['target'],$pt)>'') 
             FoxAbort($pagename, "Sorry, page \"$pt\" exists already. Please choose another page name. ");
      }
   }
   // check for 'post' from submit button and refuse empty textarea named 'text'
   // ToDo: expand this to check  array of mandatory fields ???
   if (!isset($fields['post']) OR (isset($fields['text']) AND $fields['text']=="")) {
       FoxAbort($pagename, "ERROR: No text or missing post! ");
   }
   return $fields;
} //}}}


## abort by displaying error message and retuning to page
function FoxAbort($pagename, $msg) {
   global $MessagesFmt;
   $MessagesFmt[] = "<h5 class='wikimessage'>$[$msg]</h5>";
   HandleBrowse($pagename);
   Redirect($pagename); //exit;
} //}}}

## build javascript for simple validation that required fields have values 
function FoxFormCheck($formcheck) {
   $reqfields = preg_split("/[\s,|]+/", $formcheck, -1, PREG_SPLIT_NO_EMPTY);
   $out = "   
   <script type='text/javascript' language='JavaScript1.2'><!--
     function checkform ( form ) {
      ";
   foreach($reqfields as $required) {
      $out .= 
      "if (form.$required && form.$required.value == \"\") {
           window.alert( 'Entry in field \'$required\' is required!' );
           form.$required.focus();
           return false ;
         }
      ";
   }
   $out .= 
   "return true ;
     }
   --></script>
   ";
   return $out;    
} //}}}


## provide {$AccessCode} page variable:
$FmtPV['$AccessCode'] = rand(100, 999);


## add page variable {$FoxPostCount}, counts message items per page
$FmtPV['$FoxPostCount'] = 'FoxStringCount($pn,"#foxbegin")';
function FoxStringCount($pagename,$find) {
   $page = ReadPage($pagename, READPAGE_CURRENT);
   $n = substr_count($page['text'], $find);
//   if ($n==0) return '';  #suppressing 0
   return $n;
}